/*
   Objectif : Mettre en mouvement les différents axes du robot, indéfiniment avec prise du composant
*/

//*****DECLARATIF*****
#include <Servo.h>  // on inclut la bibliothèque pour piloter un servomoteur.

Servo J1;   // J1 Servomoteur rotation par rapport au bati. Rotation du buste.
Servo J20; // J2A Servomoteur couplé à J2B de l'épaule. Rotation du bras.
Servo J21; // J2B Servomoteur couplé à J2A de l'épaule.
Servo J3;   // J3 Servomoteur du coude. Rotation de l'avant bras.
Servo J5;   // J5 Servomateur du poignet. Rotation verticale du poignet.
Servo J6;   // J6 Servomateur du poignet. Rotation horizantale du poignet.


Servo Pompe; //Dépression ventouse
Servo Lib;   // Liberation ventouse


int posJ1;  // Position de l'axe moteur J1 de 0 à 180 degrés.
int posJ0;// Position de l'axe moteur J2A.
int posJ20; // Position de l'axe moteur J2A.
int posJ21;// Position de l'axe moteur J2B=180-posJ2A.
int posJ3;  // Position de l'axe moteur J3 de 0 à 180 degrés.
int posJ5;  // Position de l'axe moteur J5 de 0 à 180 degrés.
int posJ6;  // Position de l'axe moteur J6 de 0 à 180 degrés.


void setup()
{
    J1.attach(0); // Le servomoteur J1 est piloté par le port 0.
    J20.attach(1); //Le servomoteur J1 est piloté par le port 0.
    J21.attach(2); //Le servomoteur J1 est piloté par le port 0.
    J3.attach(4); // Le servomoteur J1 est piloté par le port 0.
    J5.attach(5); // Le servomoteur J1 est piloté par le port 0.
    J6.attach(6); // Le servomoteur J1 est piloté par le port 0.
    Pompe.attach(12); // Commande pompe à vide.
    Lib.attach(13);// Relache ventouse.

//*****Prise origine axe*****
    J1.write(0); J20.write(0); J21.write(180-0); J3.write(0); J5.write(0); J6.write(0);  
    Pompe.write(0); Lib.write(0);
    delay(2000); //Pause en la postion origine axe

//*****Mise en référence machine*****
    J1.write(45); J20.write(40); J21.write(180-40); J3.write(20); J5.write(20); J6.write(30);  
    Pompe.write(0); Lib.write(0);
    delay(2000);// Pause avant départ cycle
    
}    
void loop()

//*****MOUVEMENT vers la position 1***** 

//*****POINT 1 pour la prise X=100mm  Y=80mm  Z=20mm***** 



//*****MOUVEMENT du buste - ROTATION du CORPS*****
{
{for (posJ1 = 45; posJ1 <=90; posJ1 ++) // Mouvement du buste
  J1.write(posJ1);  // Le servomoteur prend la position définie par J1
        delay(4); } // Réglage de la vitesse du mouvement
   
delay(500); // Délais entre les mouvements.

//*****MOUVEMENT Descente de la ventouse - ROTATION de l'EPAULE*****
{for (posJ20= 40; posJ20<=60; posJ20 ++) // Descente du bras
       J20.write(posJ20);  // Le servomoteur J20 prend la position de la variable position
       J21.write(180-posJ20);  // Le servomoteur J21 prend la position de la variable position décalée pour une rotation -
       delay(10); } 

{for (posJ5= 20; posJ5 >=10; posJ5 --) J5.write(posJ5); delay(10);
delay(1000);}   
       
    
delay(1000); // Délais entre le mouvement de descente et le mouvement de montée.

//*****ACTION de prise avec la ventouse*****
{Pompe.writeMicroseconds(2000);
 Lib.writeMicroseconds(1000);
delay(2000);}

//*****MOUVEMENT de montée*****
{for (posJ20= 58; posJ20>=20; posJ20 --) 
       J20.write(posJ20); J21.write(180-posJ21);delay(10);
delay(1000);} // Attente enchainement des mouvements

//*****MOUVEMENT rotation en horizantal du poignet*****
{for (posJ6 = 30; posJ6 <=90; posJ6 ++) 
      J6.write(posJ6); delay(10); 
delay(1000);} 
//*****MOUVEMENT rotation en vertical du poignet*****    
{for (posJ5 = 20; posJ5 <=50; posJ5 ++) 
  J5.write(posJ5);delay(15); 
delay(1000); }


//*****MOUVEMENT vers la position 2***** 

//*****POINT 2  pour la dépose X=-80mm  Y=-40mm  Z=25mm***** 

  
{for (posJ1 = 90; posJ1 >=20; posJ1 --) J1.write(posJ1); delay(4); delay(1000);}   

{for (posJ6 = 90; posJ6 >=0; posJ6 --) J6.write(posJ6);delay(10); delay(1000);} 
    
{for (posJ5 = 50; posJ5 >=20; posJ5 --)J5.write(posJ5);delay(10); delay(1000);}

{for (posJ20 = 20; posJ20 <=55; posJ20 ++) J20.write(posJ20);J21.write(180-posJ20);delay(10); delay(2000);}

    
//*****DEPOSE de l'objet*****    
 Pompe.writeMicroseconds(1000); delay(1000); Lib.writeMicroseconds(2000);delay(2000); 

//*****RETOUR RAPIDE vers la Prise Origine Machine*****   
J1.write(45); J20.write(40); J21.write(180-40); J3.write(20); J5.write(20); J6.write(30);  
Pompe.write(0); Lib.write(0);

{delay(3000);} //Fin de cycle du mouvement P1 vers P2.


//*****MOUVEMENT vers la position 2 - Récupération de l'objet*****

//*****POINT 2  pour la prise X=-80mm  Y=-40mm  Z=20mm*****     

{for (posJ1 = 45; posJ1 >=20; posJ1 --) J1.write(posJ1); delay(4); delay(1000);}   

{for (posJ20 = 40; posJ20 <=60; posJ20 ++) J20.write(posJ20);J21.write(180-posJ20);delay(10); delay(2000);}

//*****ACTION de prise avec la ventouse*****
{Pompe.writeMicroseconds(2000);
 Lib.writeMicroseconds(1000);
delay(2000);}

//*****MOUVEMENT vers la position 1***** 

//*****POINT 1  pour la dépose X=100mm  Y=80mm  Z=25mm***** 
 
{for (posJ20 = 60; posJ20 >=20; posJ20 --) J20.write(posJ20);J21.write(180-posJ20);delay(10); delay(2000);}

{for (posJ1 = 20; posJ1 <=90; posJ1 ++) J1.write(posJ1); delay(4); delay(1000);}  

{for (posJ6 = 30; posJ6 <=60; posJ6 ++) J6.write(posJ6);delay(15); delay(1000);} 
    
{for (posJ5 = 25; posJ5 >=15; posJ5 --)J5.write(posJ5);delay(15); delay(1000);}

{for (posJ20 = 20; posJ20 <=55; posJ20 ++) J20.write(posJ20);J21.write(180-posJ20);delay(10); delay(2000);}

//*****DEPOSE de l'objet*****    
 Lib.writeMicroseconds(2000);delay(2000); 

//*****RETOUR RAPIDE vers la Prise Origine Machine*****   
J1.write(45); J20.write(40); J21.write(180-40); J3.write(20); J5.write(20); J6.write(30);  
Pompe.write(0); Lib.write(0);

delay(2000);
} 
